local count = 0
local frame = CreateFrame("Frame")
local save_Sound_EnableErrorSpeech = GetCVar("Sound_EnableErrorSpeech")

local function Activate(arg)
	local n = tonumber(arg) or 1
	if count == 0 then
		save_Sound_EnableErrorSpeech = GetCVar("Sound_EnableErrorSpeech")
		SetCVar("Sound_EnableErrorSpeech", 0)	
	end
	count = count + n
end

local function Disactivate()
	if count > 0 then
		count = count - 1
		if count == 0 then
			SetCVar("Sound_EnableErrorSpeech", save_Sound_EnableErrorSpeech)
		end
	end
end

frame:SetScript('OnEvent', function(_, event, unit)
	if count > 0 then
		if event == 'UNIT_SPELLCAST_SUCCEEDED' and unit == 'player' then
			Disactivate() 
		elseif event == 'PLAYER_LOGOUT' then
			SetCVar("Sound_EnableErrorSpeech", save_Sound_EnableErrorSpeech)
		end
	end
end)

frame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
frame:RegisterEvent("PLAYER_LOGOUT")

local orig_UIErrorsFrame_OnEvent = UIErrorsFrame:GetScript('OnEvent')
UIErrorsFrame:SetScript('OnEvent', function(self, event, ...)
	if count > 0 and event == "UI_ERROR_MESSAGE" then
		return Disactivate()
	else
		return orig_UIErrorsFrame_OnEvent(self, event, ...)
	end
end)

SLASH_QUIETCAST1 = "/quietcast"
SLASH_QUIETCAST2 = "/quiet"
SLASH_QUIETCAST1 = "/qc"
SlashCmdList.QUIETCAST = Activate
